﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Data.OleDb;

using System.Reflection;
using System.Xml;
using System.Xml.Serialization;


//using RavSoft.GoogleTranslator;



namespace TestNapLib
{
    public partial class Form1 : Form
    {
        public string fname;
        public MD_Metadata_Type md;


        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void ReadNap(object sender, EventArgs e)
        {
            if (this.openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                this.fname = this.openFileDialog1.FileName;
                XmlDocument doc = new XmlDocument();
                doc.Load(this.fname);

                System.IO.FileStream fs;
                try {  fs = new System.IO.FileStream(this.fname, System.IO.FileMode.Open); }
                catch (System.Exception ex )
                {
                    MessageBox.Show(this.fname + " " + ex.Message.ToString());
                    return;
                }
               
                md = new MD_Metadata_Type();

                System.Xml.Serialization.XmlSerializer sr = new System.Xml.Serialization.XmlSerializer(md.GetType());
                sr.UnknownAttribute += sr_UnknownAttribute;
                sr.UnknownElement += sr_UnknownElement;
                sr.UnreferencedObject += sr_UnreferencedObject;
                //sr.UnknownNode += new XmlNodeEventHandler(serial);
                try { 
                    md = (MD_Metadata_Type)sr.Deserialize(fs);
                }
 
               catch ( System.Exception eX )
                {
                        MessageBox.Show(this.fname + " " +eX.Message.ToString());
                        fs.Close();
                        return;
                }

                fs.Close();

                //TimePeriodType tpt = new TimePeriodType();
                //if (md.identificationInfo[0].MD_DataIdentification.extent[1].EX_Extent.temporalElement[0].EX_TemporalExtent.extent.TimePeriod == null)
                //{
                //    md.identificationInfo[0].MD_DataIdentification.extent[1].EX_Extent.temporalElement[0].EX_TemporalExtent.extent.TimePeriod = tpt;
                //    tpt.
                //}

                // fill in tab pages
                FillInPages();

            }
      
        }

        void sr_UnknownAttribute(object sender, XmlAttributeEventArgs e)
        {
            return;

        }

        void sr_UnreferencedObject(object sender, UnreferencedObjectEventArgs e)
        {
            return;
        }

        void sr_UnknownElement(object sender, XmlElementEventArgs e)
        {
            return;
        }
        static void UnknownNode(object sender, XmlNodeEventArgs e)
        {
            Console.WriteLine("Unexpected node: {0} as line {1}, column {2}",
                e.LocalName, e.LineNumber, e.LinePosition);
        }

        static void UnknownElement(object sender, XmlElementEventArgs e)
        {
            Console.WriteLine("Unexpected element: {0} as line {1}, column {2}",
                e.Element.Name, e.LineNumber, e.LinePosition);
        }

        static void UnknownAttribute(object sender, XmlAttributeEventArgs e)
        {
            Console.WriteLine("Unexpected attribute: {0} as line {1}, column {2}",
                e.Attr.Name, e.LineNumber, e.LinePosition);
        }


        void FillInPages()
        {
            // page 1 contact
            LcontactOrganizationEnglishName.Text = md.contact[0].CI_ResponsibleParty.organisationName.CharacterString;
            LcontactFrenchOriganizationName.Text =((PT_FreeText_PropertyType)(md.contact[0].CI_ResponsibleParty.organisationName)).PT_FreeText.textGroup[0].LocalisedCharacterString.Value;
            LcontactEnglishEmail.Text = md.contact[0].CI_ResponsibleParty.contactInfo.CI_Contact.address.CI_Address.electronicMailAddress[0].CharacterString;
            LcontactFrenchEmail.Text = md.contact[0].CI_ResponsibleParty.contactInfo.CI_Contact.address.CI_Address.electronicMailAddress[0].CharacterString; ;


            //page 2 - reference system

            Lcode.Text = md.referenceSystemInfo[0].MD_ReferenceSystem.referenceSystemIdentifier.RS_Identifier.code.CharacterString;
            Lcodespace.Text = md.referenceSystemInfo[0].MD_ReferenceSystem.referenceSystemIdentifier.RS_Identifier.codeSpace.CharacterString;
            Lversion.Text = md.referenceSystemInfo[0].MD_ReferenceSystem.referenceSystemIdentifier.RS_Identifier.version.CharacterString;

            // page 3 - citation

            AbstractMD_Identification_Type AbstractMD = (AbstractMD_Identification_Type)(md.identificationInfo[0].MD_DataIdentification);

            LenglishTitle.Text = AbstractMD.citation.CI_Citation.title.CharacterString;

            PT_FreeText_PropertyType otherLang = (PT_FreeText_PropertyType)AbstractMD.citation.CI_Citation.title;
            LfrenchTitle.Text = otherLang.PT_FreeText.textGroup[0].LocalisedCharacterString.Value;

            LcreationDate.Text=      AbstractMD.citation.CI_Citation.date[0].CI_Date.date.Item.ToString();
            LcreationDateType.Text = AbstractMD.citation.CI_Citation.date[0].CI_Date.dateType.CI_DateTypeCode.Value;
            LpublicationDate.Text = AbstractMD.citation.CI_Citation.date[1].CI_Date.date.Item.ToString();
            LpublicationType.Text = AbstractMD.citation.CI_Citation.date[1].CI_Date.dateType.CI_DateTypeCode.Value;

            LcitationEnglishOrganizationName.Text = AbstractMD.citation.CI_Citation.citedResponsibleParty[0].CI_ResponsibleParty.organisationName.CharacterString;
            LcitationFrenchOrganizationName.Text = ((PT_FreeText_PropertyType)(AbstractMD.citation.CI_Citation.citedResponsibleParty[0].CI_ResponsibleParty.organisationName)).PT_FreeText.textGroup[0].LocalisedCharacterString.Value;
            LcitationEnglishEmail.Text = AbstractMD.citation.CI_Citation.citedResponsibleParty[0].CI_ResponsibleParty.contactInfo.CI_Contact.address.CI_Address.electronicMailAddress[0].CharacterString;
            LcitationFrenchEmail.Text = LcitationEnglishEmail.Text ;
            if (AbstractMD.citation.CI_Citation.citedResponsibleParty[0].CI_ResponsibleParty.contactInfo.CI_Contact.address.CI_Address.electronicMailAddress.Length > 1)
            {
                LcitationFrenchEmail.Text = AbstractMD.citation.CI_Citation.citedResponsibleParty[0].CI_ResponsibleParty.contactInfo.CI_Contact.address.CI_Address.electronicMailAddress[1].CharacterString;

            }
            LcitationRole.Text = AbstractMD.citation.CI_Citation.citedResponsibleParty[0].CI_ResponsibleParty.role.CI_RoleCode.Value;

            // page 4 - abstract 
            LenglishAbstract.Text = AbstractMD.@abstract.CharacterString;
            LfrenchAbstract.Text = ((PT_FreeText_PropertyType)AbstractMD.@abstract).PT_FreeText.textGroup[0].LocalisedCharacterString.Value;
            Lstatus.Text = AbstractMD.status[0].MD_ProgressCode.Value;
            LmaintenanceFrequency.Text = AbstractMD.resourceMaintenance[0].MD_MaintenanceInformation.maintenanceAndUpdateFrequency.MD_MaintenanceFrequencyCode.Value;


            // page 5 keywords

            MD_Keywords_PropertyType[] keywords = AbstractMD.descriptiveKeywords;
            listboxKeywords.Items.Clear();
            for (int i = 0; i < keywords.Length;  i++)
            {
                CharacterString_PropertyType[] keys = keywords[i].MD_Keywords.keyword;
                for (int j = 0; j < keys.Length; j++)
                {
                    listboxKeywords.Items.Add(keys[j].CharacterString);

                }
            }

            // page 6 spatial representation
            MD_SpatialRepresentationTypeCode_PropertyType MD_SpatialRepresentationTypeCode = md.identificationInfo[0].MD_DataIdentification.spatialRepresentationType[0];
            LspatialRepresentationType.Text =  MD_SpatialRepresentationTypeCode.MD_SpatialRepresentationTypeCode.Value;

            MD_DataIdentification_Type  MD_DataIdentification = md.identificationInfo[0].MD_DataIdentification;
            LdataLanguage.Items.Clear();
            for ( int i = 0; i < MD_DataIdentification.language.Length; i++) LdataLanguage.Items.Add(MD_DataIdentification.language[i].CharacterString);
            LtopicCategory.Text = MD_DataIdentification.topicCategory[0].MD_TopicCategoryCode.ToString();

            
        }
        /// <summary>
        /// Read the top level metadata entries
        /// </summary>
        private void getMainPageFromNap()
        {
            if (this.md == null) return;

        }

        private void button1_Click_1(object sender, System.EventArgs e)
        {
            //RavSoft.GoogleTranslator.Translator t = new Translator();
            //this.LfrenchAbstract.Text = t.Translate(this.LenglishAbstract.Text.Trim(), "en", "fr");
            
        }

        private void textBox49_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox49_Enter(object sender, EventArgs e)
        {
            // pop up thesauarus 
            //TestNapLib.EnglishThesaures et = new EnglishThesaures();
            //et.Show();
        }

        private void textBox49_DoubleClick(object sender, EventArgs e)
        {
            // pop up thesauarus 

        }

        /// <summary>
        /// Add to keyword from external form
        /// </summary>
        public void AddToKeyWordList(string keyword)
        {
            this.listboxKeywords.Items.Add(keyword);
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            TestNapLib.EnglishThesaures et = new EnglishThesaures(this);
            et.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int i = this.listboxKeywords.SelectedIndex;
            if (i >= 0) this.listboxKeywords.Items.RemoveAt(i);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.listboxKeywords.Items.Clear();
        }

        private void listBox1_SelectedValueChanged(object sender, EventArgs e)
        {
            if (listboxKeywords.SelectedIndex < 0) return;
            this.textBox2.Text = this.listboxKeywords.SelectedItem.ToString();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            this.listboxKeywords.Items.Add(this.textBox2.Text);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if ( listboxKeywords.SelectedIndex >= 0 )
            {
                listboxKeywords.Items[listboxKeywords.SelectedIndex] = textBox2.Text;
            }
        }

        private void textBox7_KeyPress(object sender, KeyPressEventArgs e)
        {
            // validate to only allow numbers
            if (e.KeyChar >= '0' && e.KeyChar <= '9' || e.KeyChar == '-' || e.KeyChar == '.' || e.KeyChar == '\b' || e.KeyChar == '\n' || e.KeyChar == '\r') //The  character represents a backspace
            {
                e.Handled = false; //Do not reject the input
            }
            else
            {
                MessageBox.Show("Enter decimal degrees ; - for west or south ; e.g. -147.50 ");
                string text = LwestBoundingLongitude.Text;
                if( text.Length >= 1 ) LwestBoundingLongitude.Text = text.Substring(0, text.Length - 1);
            }
        }
    }
}
